;
;  Disassembly of the Sprite-Imation library.
;
;  Written by Daniel Gray
;  Originally published in "Compute's Vic-20 Collection"
;
;  Disassembled by Mike "Hawk" Hawkey
;

;
;  For reference, this id the dissassembly of the default
;  CHRGET subroutine at $0073 that gets the next BASIC
;  character/token.
;
;  CHRGET: 
;  C:0073   E6 7A      INC $7A
;  C:0075   D0 02      BNE $0079
;  C:0077   E6 7B      INC $7B
;  C:0079   AD 00 10   LDA $1000
;  C:007c   C9 3A      CMP #$3A
;  C:007e   B0 0A      BCS $008A
;  C:0080   C9 20      CMP #$20
;  C:0082   F0 EF      BEQ $0073
;  C:0084   38         SEC
;  C:0085   E9 30      SBC #$30
;  C:0087   38         SEC
;  C:0088   E9 D0      SBC #$D0
;  C:008a   60         RTS

;  C:02a1   .db 00     ; Temp storage for accumulator
;  C:02a2   .db 00     ; Temp storage for x register
;  C:02a3   .db 00     ; Temp storage for y register

title:
.C:167a  .db 0d 0d 9c 1d  1d 1d 1d 53   ; ".......SPRITE-IMATION..."
.C:1682  .db 50 52 49 54  45 2d 49 4d   
.C:168a  .db 41 54 49 4f  4e 1f 0d 00     

interpret_basic:
.C:1692   C9 88      CMP #$88           ; Check for LET BASIC token
.C:1694   F0 0A      BEQ $16A0

.C:1696   C9 3A      CMP #$3A           ; Check for a ':'
.C:1698   B0 03      BCS $169D
.C:169a   4C 80 00   JMP $0080          ; 
.C:169d   4C 8A 00   JMP $008A          ; Colon found, continue CHGET subroutine

.C:16a0   20 4F 17   JSR $174F          ; Save registers
.C:16a3   20 73 00   JSR $0073          ; Call CHGET again to get next character/token

.C:16a6   C9 00      CMP #$00           ; Check for end of BASIC line.
.C:16a8   D0 05      BNE $16AF          ; Not end-of-line so keep processing
.C:16aa   20 5D 17   JSR $175D          ; Restore registers (not inc. A)
.C:16ad   10 E7      BPL $1696

.C:16af   C9 5C      CMP #$5C           ; Check for 'pound' character
.C:16b1   D0 13      BNE $16C6          ; if not equal, jump to next check
.C:16b3   AD D5 02   LDA $02D5          ; Get number of sprites
.C:16b6   D0 02      BNE $16BA          ; Check for zero sprites
.C:16b8   A9 04      LDA #$04           
.C:16ba   C9 05      CMP #$05           ; If number of sprites is more than 4
.C:16bc   B0 FA      BCS $16B8          ; then subtract 4 until it isn't.
.C:16be   8D EE 1D   STA $1DEE          ; Store number of sprites into Main program.
.C:16c1   20 DC 1D   JSR $1DDC          ; Call PROCESS_SPRITES
.C:16c4   90 DD      BCC $16A3          ; Check if the Accumulator contains the next character

.C:16c6   C9 5F      CMP #$5F           ; Check for '<-' character
.C:16c8   D0 07      BNE $16D1          ; if not equal, jump to next check
.C:16ca   A9 93      LDA #$93           ; Load 'Clear' token and
.C:16cc   20 D2 FF   JSR $FFD2          ; jump to CHAROUT vector
.C:16cf   90 D2      BCC $16A3          ; Check if the Accumulator contains the next character

.C:16d1   C9 3A      CMP #$3A           ; Check for ':' character
.C:16d3   D0 03      BNE $16D8          ; if not equal, jump to next check
.C:16d5   38         SEC                ; Set 'Carry' to indicate line not finished
.C:16d6   B0 CB      BCS $16A3          ; Pseudo JMP to get next character/token

.C:16d8   C9 40      CMP #$40           ; Check for '@' character
.C:16da   D0 BA      BNE $1696
.C:16dc   20 73 00   JSR $0073          ; Call CHGET again to get next character/token
.C:16df   B0 2D      BCS $170E          ; 
.C:16e1   C9 34      CMP #$34           ; Check for '"'
.C:16e3   B0 29      BCS $170E
.C:16e5   38         SEC
.C:16e6   E9 2F      SBC #$2F
.C:16e8   A8         TAY
.C:16e9   99 E3 02   STA $02E3,Y
.C:16ec   0A         ASL A
.C:16ed   85 9E      STA $9E
.C:16ef   20 73 00   JSR $0073          ; Call CHGET again to get next character/token
.C:16f2   A0 02      LDY #$02
.C:16f4   84 9F      STY $9F
.C:16f6   20 FD CE   JSR $CEFD          ; -test comma-
.C:16f9   20 8A CD   JSR $CD8A          ; Confirm Result
.C:16fc   20 F7 D7   JSR $D7F7          ; Convert FAC#1 to Integer in LINNUM
.C:16ff   98         TYA
.C:1700   A4 9E      LDY $9E
.C:1702   99 D8 02   STA $02D8,Y
.C:1705   E6 9E      INC $9E
.C:1707   A4 9F      LDY $9F
.C:1709   88         DEY
.C:170a   D0 E8      BNE $16F4          ; 
.C:170c   F0 95      BEQ $16A3          ; Get next Character/token
.C:170e   4C 08 CF   JMP $CF08          ; Output ?SYNTAX Error

.C:1711   20 50 17   JSR $1750
.C:1714   4E 22 91   LSR $9122
.C:1717   AD 20 91   LDA $9120
.C:171a   09 7F      ORA #$7F
.C:171c   6A         ROR A
.C:171d   2D 11 91   AND $9111
.C:1720   AA         TAX
.C:1721   0A         ASL A
.C:1722   0A         ASL A
.C:1723   0A         ASL A
.C:1724   8A         TXA
.C:1725   69 00      ADC #$00
.C:1727   29 5F      AND #$5F
.C:1729   49 7E      EOR #$7E
.C:172b   C9 60      CMP #$60
.C:172d   B0 02      BCS $1731
.C:172f   49 60      EOR #$60
.C:1731   A0 03      LDY #$03
.C:1733   AA         TAX
.C:1734   29 03      AND #$03
.C:1736   C9 02      CMP #$02
.C:1738   B0 02      BCS $173C
.C:173a   49 01      EOR #$01
.C:173c   99 D5 02   STA $02D5,Y
.C:173f   8A         TXA
.C:1740   4A         LSR A
.C:1741   4A         LSR A
.C:1742   88         DEY
.C:1743   D0 EE      BNE $1733
.C:1745   38         SEC
.C:1746   2E 22 91   ROL $9122
.C:1749   20 5A 17   JSR $175A
.C:174c   4C 70 F7   JMP $F770          ; STOP - Check STOP key

save_registers:
.C:174f   78         SEI                ; Store the registers
.C:1750   8D A1 02   STA $02A1            
.C:1753   8E A2 02   STX $02A2
.C:1756   8C A3 02   STY $02A3
.C:1759   60         RTS

restore_registers:
.C:175a   AD A1 02   LDA $02A1          ; Restore the registers
.C:175d   AE A2 02   LDX $02A2
.C:1760   AC A3 02   LDY $02A3
.C:1763   58         CLI
.C:1764   60         RTS

.C:1765   BD 3C 03   LDA $033C,X
.C:1768   85 9E      STA $9E
.C:176a   BD 3D 03   LDA $033D,X
.C:176d   85 9F      STA $9F
.C:176f   60         RTS

INITIALISE:
.C:1770   78         SEI                ; Initialise the Sprite-Imation library
.C:1771   18         CLC
.C:1772   A2 7A      LDX #$7A
.C:1774   A0 16      LDY #$16
.C:1776   20 99 FF   JSR $FF99          ; Set/Read MEMTOP to $167A
.C:1779   20 A4 E3   JSR $E3A4          ; initcz - Initialise BASIC RAM
.C:177c   A2 04      LDX #$04           ; Modify the CHRGET subroutine which gets the
.C:177e   BD A5 17   LDA $17A5,X        ; next BASIC character to call the custom
.C:1781   95 7B      STA $7B,X          ; routine.
.C:1783   CA         DEX
.C:1784   D0 F8      BNE $177E
.C:1786   A9 FE      LDA #$FE
.C:1788   8D 05 90   STA $9005          ; Set the address of Character memory and Video memory
.C:178b   A9 11      LDA #$11
.C:178d   A0 17      LDY #$17
.C:178f   8D 28 03   STA $0328          ; Set Test-STOP vector to $1711
.C:1792   8C 29 03   STY $0329
.C:1795   A6 33      LDX $33
.C:1797   20 04 E4   JSR $E404          ; initms - Output Power-up message
.C:179a   A9 7A      LDA #$7A
.C:179c   A0 16      LDY #$16
.C:179e   20 1E CB   JSR $CB1E          ; strout - Output string "SPRITE IMATION"
.C:17a1   58         CLI
.C:17a2   4C 81 E3   JMP $E381          ; Jump part-way into init - BASIC Cold Start

.C:17a5   EA         NOP
.C:17a6   4C 92 16   JMP $1692



.Sprite_1_Data      .dw 00

.C:1be0   A9 00      LDA #$00
.C:1be2   85 93      STA $93            ; Zero 
.C:1be4   85 92      STA $92            ; Zero 
.C:1be6   99 F4 02   STA $02F4,Y        ; Zero Sprite-sprite collision register
.C:1be9   99 FA 02   STA $02FA,Y        ; Zero Sprite-background collision register
.C:1bec   B9 D0 02   LDA $02D0,Y        ; Get location of sprite data
.C:1bef   18         CLC
.C:1bf0   79 D0 02   ADC $02D0,Y
.C:1bf3   26 93      ROL $93
.C:1bf5   18         CLC
.C:1bf6   79 D0 02   ADC $02D0,Y
.C:1bf9   26 93      ROL $93
.C:1bfb   A2 04      LDX #$04
.C:1bfd   0A         ASL A
.C:1bfe   26 93      ROL $93
.C:1c00   CA         DEX
.C:1c01   D0 FA      BNE $1BFD
.C:1c03   85 92      STA $92
.C:1c05   98         TYA
.C:1c06   0A         ASL A
.C:1c07   8D FF 02   STA $02FF
.C:1c0a   A8         TAY
.C:1c0b   B9 F4 17   LDA $17F4,Y
.C:1c0e   BE F5 17   LDX $17F5,Y
.C:1c11   85 B0      STA $B0
.C:1c13   86 B1      STX $B1
.C:1c15   A9 1A      LDA #$1A
.C:1c17   85 58      STA $58
.C:1c19   85 5A      STA $5A
.C:1c1b   BE DA 02   LDX $02DA,Y
.C:1c1e   B9 DB 02   LDA $02DB,Y
.C:1c21   86 C4      STX $C4
.C:1c23   A0 02      LDY #$02
.C:1c25   48         PHA
.C:1c26   29 07      AND #$07
.C:1c28   C0 02      CPY #$02
.C:1c2a   F0 07      BEQ $1C33
.C:1c2c   AE EA 02   LDX $02EA
.C:1c2f   F0 02      BEQ $1C33
.C:1c31   29 FE      AND #$FE
.C:1c33   99 C9 02   STA $02C9,Y
.C:1c36   68         PLA
.C:1c37   4A         LSR A
.C:1c38   4A         LSR A
.C:1c39   4A         LSR A
.C:1c3a   99 C7 02   STA $02C7,Y
.C:1c3d   A5 C4      LDA $C4
.C:1c3f   88         DEY
.C:1c40   D0 E3      BNE $1C25
.C:1c42   AD CB 02   LDA $02CB
.C:1c45   85 59      STA $59
.C:1c47   18         CLC
.C:1c48   69 08      ADC #$08
.C:1c4a   85 57      STA $57
.C:1c4c   A0 5F      LDY #$5F
.C:1c4e   A9 00      LDA #$00
.C:1c50   99 00 1A   STA $1A00,Y
.C:1c53   88         DEY
.C:1c54   10 FA      BPL $1C50
.C:1c56   18         CLC
.C:1c57   A0 18      LDY #$18
.C:1c59   88         DEY
.C:1c5a   B1 92      LDA ($92),Y
.C:1c5c   91 59      STA ($59),Y
.C:1c5e   98         TYA
.C:1c5f   48         PHA
.C:1c60   69 18      ADC #$18
.C:1c62   A8         TAY
.C:1c63   B1 92      LDA ($92),Y
.C:1c65   91 57      STA ($57),Y
.C:1c67   68         PLA
.C:1c68   A8         TAY
.C:1c69   D0 EE      BNE $1C59
.C:1c6b   A0 18      LDY #$18
.C:1c6d   A6 59      LDX $59
.C:1c6f   84 FB      STY $FB
.C:1c71   AC CA 02   LDY $02CA
.C:1c74   F0 0D      BEQ $1C83
.C:1c76   18         CLC
.C:1c77   7E 00 1A   ROR $1A00,X
.C:1c7a   7E 20 1A   ROR $1A20,X
.C:1c7d   7E 40 1A   ROR $1A40,X
.C:1c80   88         DEY
.C:1c81   D0 F3      BNE $1C76
.C:1c83   E8         INX
.C:1c84   A4 FB      LDY $FB
.C:1c86   88         DEY
.C:1c87   D0 E6      BNE $1C6F
.C:1c89   A2 00      LDX #$00
.C:1c8b   86 59      STX $59
.C:1c8d   A0 00      LDY #$00
.C:1c8f   8E C6 02   STX $02C6
.C:1c92   8C C7 02   STY $02C7
.C:1c95   8A         TXA
.C:1c96   0A         ASL A
.C:1c97   0A         ASL A
.C:1c98   18         CLC
.C:1c99   6D C7 02   ADC $02C7
.C:1c9c   85 57      STA $57
.C:1c9e   20 F3 1D   JSR $1DF3
.C:1ca1   65 57      ADC $57
.C:1ca3   85 FB      STA $FB
.C:1ca5   0A         ASL A
.C:1ca6   AA         TAX
.C:1ca7   20 65 17   JSR $1765
.C:1caa   AD C8 02   LDA $02C8
.C:1cad   18         CLC
.C:1cae   6D C6 02   ADC $02C6
.C:1cb1   AA         TAX
.C:1cb2   AD C9 02   LDA $02C9
.C:1cb5   6D C7 02   ADC $02C7
.C:1cb8   A8         TAY
.C:1cb9   20 AA 17   JSR $17AA
.C:1cbc   A0 00      LDY #$00
.C:1cbe   A6 FB      LDX $FB
.C:1cc0   A5 92      LDA $92
.C:1cc2   C5 9E      CMP $9E
.C:1cc4   D0 06      BNE $1CCC
.C:1cc6   A5 93      LDA $93
.C:1cc8   C5 9F      CMP $9F
.C:1cca   F0 1E      BEQ $1CEA
.C:1ccc   B1 9E      LDA ($9E),Y
.C:1cce   38         SEC
.C:1ccf   E5 C4      SBC $C4
.C:1cd1   C9 4C      CMP #$4C
.C:1cd3   90 15      BCC $1CEA
.C:1cd5   C9 58      CMP #$58
.C:1cd7   B0 11      BCS $1CEA
.C:1cd9   BD B4 03   LDA $03B4,X
.C:1cdc   91 9E      STA ($9E),Y
.C:1cde   A5 9F      LDA $9F
.C:1ce0   18         CLC
.C:1ce1   69 78      ADC #$78
.C:1ce3   85 9F      STA $9F
.C:1ce5   BD 00 94   LDA $9400,X
.C:1ce8   91 9E      STA ($9E),Y
.C:1cea   B1 92      LDA ($92),Y
.C:1cec   85 C3      STA $C3
.C:1cee   48         PHA
.C:1cef   A5 93      LDA $93
.C:1cf1   18         CLC
.C:1cf2   69 78      ADC #$78
.C:1cf4   85 5C      STA $5C
.C:1cf6   B1 5B      LDA ($5B),Y
.C:1cf8   A8         TAY
.C:1cf9   68         PLA
.C:1cfa   C9 4C      CMP #$4C
.C:1cfc   90 13      BCC $1D11
.C:1cfe   B0 08      BCS $1D08

>C:1d00  ff ff ff ff  ff ff ff ff   ........

.C:1d08   E9 4C      SBC #$4C
.C:1d0a   AA         TAX
.C:1d0b   BD B4 03   LDA $03B4,X
.C:1d0e   BC 00 94   LDY $9400,X
.C:1d11   C9 20      CMP #$20
.C:1d13   F0 06      BEQ $1D1B
.C:1d15   AE FC 03   LDX $03FC
.C:1d18   9D FA 02   STA $02FA,X
.C:1d1b   A6 FB      LDX $FB
.C:1d1d   9D B4 03   STA $03B4,X
.C:1d20   98         TYA
.C:1d21   9D 00 94   STA $9400,X
.C:1d24   A0 00      LDY #$00
.C:1d26   B1 92      LDA ($92),Y
.C:1d28   38         SEC
.C:1d29   E9 4C      SBC #$4C
.C:1d2b   C5 FB      CMP $FB
.C:1d2d   90 14      BCC $1D43
.C:1d2f   BD B4 03   LDA $03B4,X
.C:1d32   85 C3      STA $C3
.C:1d34   AE FC 03   LDX $03FC
.C:1d37   BD EE 02   LDA $02EE,X
.C:1d3a   CC EA 02   CPY $02EA
.C:1d3d   F0 02      BEQ $1D41
.C:1d3f   09 08      ORA #$08
.C:1d41   91 5B      STA ($5B),Y
.C:1d43   A9 17      LDA #$17
.C:1d45   8D 72 1D   STA $1D72
.C:1d48   A5 C3      LDA $C3
.C:1d4a   C9 4C      CMP #$4C
.C:1d4c   90 0D      BCC $1D5B
.C:1d4e   C9 58      CMP #$58
.C:1d50   B0 03      BCS $1D55
.C:1d52   8D F4 02   STA $02F4
.C:1d55   AE FC 03   LDX $03FC
.C:1d58   9D F4 02   STA $02F4,X
.C:1d5b   38         SEC
.C:1d5c   EE 72 1D   INC $1D72
.C:1d5f   E9 20      SBC #$20
.C:1d61   30 04      BMI $1D67
.C:1d63   85 C3      STA $C3
.C:1d65   10 F4      BPL $1D5B
.C:1d67   B8         CLV
.C:1d68   A5 C3      LDA $C3
.C:1d6a   0A         ASL A
.C:1d6b   0A         ASL A
.C:1d6c   0A         ASL A
.C:1d6d   8D 71 1D   STA $1D71
.C:1d70   B9 00 19   LDA $1900,Y
.C:1d73   11 59      ORA ($59),Y
.C:1d75   91 59      STA ($59),Y
.C:1d77   C8         INY
.C:1d78   C0 08      CPY #$08
.C:1d7a   D0 F4      BNE $1D70
.C:1d7c   A0 00      LDY #$00
.C:1d7e   A5 57      LDA $57
.C:1d80   18         CLC
.C:1d81   69 40      ADC #$40
.C:1d83   91 92      STA ($92),Y
.C:1d85   A5 FB      LDA $FB
.C:1d87   0A         ASL A
.C:1d88   AA         TAX
.C:1d89   A5 92      LDA $92
.C:1d8b   9D 3C 03   STA $033C,X
.C:1d8e   A5 93      LDA $93
.C:1d90   9D 3D 03   STA $033D,X
.C:1d93   A5 59      LDA $59
.C:1d95   18         CLC
.C:1d96   69 08      ADC #$08
.C:1d98   85 59      STA $59
.C:1d9a   AE C6 02   LDX $02C6
.C:1d9d   AC C7 02   LDY $02C7
.C:1da0   C8         INY
.C:1da1   C0 04      CPY #$04
.C:1da3   F0 03      BEQ $1DA8
.C:1da5   4C 8F 1C   JMP $1C8F
.C:1da8   E8         INX
.C:1da9   E0 03      CPX #$03
.C:1dab   F0 03      BEQ $1DB0
.C:1dad   4C 8D 1C   JMP $1C8D
.C:1db0   A0 5F      LDY #$5F
.C:1db2   B9 00 1A   LDA $1A00,Y
.C:1db5   91 B0      STA ($B0),Y
.C:1db7   88         DEY
.C:1db8   10 F8      BPL $1DB2
.C:1dba   20 F3 1D   JSR $1DF3
.C:1dbd   0A         ASL A
.C:1dbe   AA         TAX
.C:1dbf   A9 4C      LDA #$4C
.C:1dc1   18         CLC
.C:1dc2   65 C4      ADC $C4
.C:1dc4   A8         TAY
.C:1dc5   69 0C      ADC #$0C
.C:1dc7   85 C3      STA $C3
.C:1dc9   98         TYA
.C:1dca   48         PHA
.C:1dcb   20 65 17   JSR $1765
.C:1dce   A0 00      LDY #$00
.C:1dd0   68         PLA
.C:1dd1   91 9E      STA ($9E),Y
.C:1dd3   A8         TAY
.C:1dd4   C8         INY
.C:1dd5   E8         INX
.C:1dd6   E8         INX
.C:1dd7   C4 C3      CPY $C3
.C:1dd9   D0 EE      BNE $1DC9
.C:1ddb   60         RTS

PROCESS_SPRITES:
.C:1ddc   A0 00      LDY #$00           ; Initialise sprite index to zero
next_sprite:
.C:1dde   8C FC 03   STY $03FC          ; Store current sprite index
.C:1de1   B9 E4 02   LDA $02E4,Y        ; Check if sprite is enabled
.C:1de4   85 BF      STA $BF            ; Store state of sprite to page zero
.C:1de6   20 E0 1B   JSR $1BE0          ; Process sprite
.C:1de9   AC FC 03   LDY $03FC          ; Restore the current sprite index
.C:1dec   C8         INY                ; Increment to the next sprite
.C:1ded   C0 04      CPY #$04           ; Check if we've processed all sprites
.C:1def   D0 ED      BNE $1DDE next_sprite:         ; If not, loop back to process this sprite.
.C:1df1   18         CLC                ; 
.C:1df2   60         RTS

.C:1df3   AD FF 02   LDA $02FF
.C:1df6   0A         ASL A
.C:1df7   85 C4      STA $C4
.C:1df9   0A         ASL A
.C:1dfa   18         CLC
.C:1dfb   65 C4      ADC $C4
.C:1dfd   85 C4      STA $C4
.C:1dff   60         RTS
